//package ij.plugin;

import ij.*;
import ij.plugin.frame.*;
import ij.util.Tools;
import ij.text.TextWindow;
import ij.gui.GUI;
import ij.process.*;


import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import java.awt.event.*;
import java.net.URL;
import java.io.CharArrayWriter;
import java.io.PrintWriter;

import quicktime.std.movies.media.AudioMediaHandler;
import quicktime.std.movies.media.TextMediaHandler;
import quicktime.std.movies.media.VideoMediaHandler;
import quicktime.std.movies.media.Media;
import quicktime.std.movies.media.MediaHandler;
import quicktime.std.movies.media.MediaEQSpectrumBands;
import quicktime.qd.QDGraphics;
import quicktime.QTException;
import quicktime.QTSession;
import quicktime.app.view.MoviePlayer;
import quicktime.app.view.QTFactory;
import quicktime.app.view.QTJComponent;
import quicktime.app.view.QTComponent;
import quicktime.std.movies.Movie;
import quicktime.std.movies.MovieController;
import quicktime.std.movies.Track;
import quicktime.io.OpenMovieFile;
import quicktime.io.QTFile;
import quicktime.app.time.TaskAllMovies;



public class Custom_QT_Player extends PlugInFrame implements KeyEventDispatcher, MouseListener, ChangeListener{

  private JButton tobeginnButton, revButton,
                      startButton,fwdButton, toendButton;
  private JSlider manipSlider;
  private JPanel contentPane;
  private JPanel buttons;
  private JPanel canvasPanel;
  private JPanel sliderPanel;
  private JPanel meterPanel;
  private JLabel timeLabel=new JLabel("--:--:--", JLabel.CENTER);
  private boolean startStop = true, flipflop=false, isAudioMedia, isVRMedia, isTextMedia;
  private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
  private Border grayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.gray, Color.gray);
  private Border lightGrayBorder = BorderFactory.createBevelBorder(bb.LOWERED, new Color(144,152,248), new Color(144,152,248));
  private long mouseDownTime;
  private static int current;
  public static final int DOUBLE_CLICK_THRESHOLD = 50;
  private boolean pressed;

  private AudioMediaHandler audioMediaHandler;
  private TextMediaHandler textMediaHandler;
  private VideoMediaHandler videoMediaHandler;
  //private QTVRMediaHandler qTVRMediaHandler;
  private Movie theMovie, m;
  private int clickValue = 0;
  private MoviePlayer mp ;
  private MovieController controller;
  private QTJComponent qtcj ;
  private JComponent jc;
  private QTComponent qtc ;
  private Component c;
  private int sliderWidth=120, sliderHeight=20;
  private static boolean lookAndFeelSet;
  protected static String metal= "Metal";
  public static int VIDEO_MOVIE =0, TEXT_MOVIE= 0;
  public static int VIDEO_AUDIO_MOVIE= 32;
  public static int VR_MOVIE= 1088;

  private static Dimension meterMinSize =
      new Dimension (200/6, 25);
  private LevelMeter meter=null;
  private int[] EQ_LEVELS = {
      32,
      64,
      125,
      250,
      500,
      1000,
      2000,
      4000,
      8000,
      16000
  };
        boolean done;
        double timeScale;
        double previousTime = -1;
        int n;

        public Custom_QT_Player() {
                super("");
                try {
                        QTSession.open();
                        QTFile f = QTFile.standardGetFilePreview (new int[0]);
                        if (f==null)
                                {QTSession.close(); return;}
                        OpenMovieFile omf = OpenMovieFile.asRead (f);
                        m = Movie.fromFile(omf);

                        theMovie = m;
                        //System.out.println("f.getName()=" + f.getName());
                        controller = new MovieController (theMovie);
                        this.setTitle(f.getName());
                        for (int i=1; i<=theMovie.getTrackCount(); i++) {
                            Track t = theMovie.getTrack(i);
                            Media media = Media.fromTrack (t);
                            //Media media = t.getMedia();
                            MediaHandler mh = media.getHandler();
                            if (mh instanceof AudioMediaHandler) {
                                audioMediaHandler = (AudioMediaHandler) mh;
                                break;
                              }
                              else if (mh instanceof VideoMediaHandler){
                                videoMediaHandler = (VideoMediaHandler) mh;
                                  //System.out.println ("video track not found !!!");
                                  break;
                            }
                            else if (mh instanceof TextMediaHandler)
                                           {textMediaHandler = (TextMediaHandler) mh;break;
                                       }
                                       /*else if (mh instanceof QTVRMediaHandler)
                                                      {qTVRMediaHandler = (QTVRMediaHandler) mh;
                                                        break;
                                                  }*/
                       }
                       if (audioMediaHandler != null ) {
                           System.out.println ("yes audio track");
                           isAudioMedia=true;
                           //System.exit(-1);
                       }
                       else if (textMediaHandler != null) {
                           System.out.println ("No video track");
                           isTextMedia=true;
                           //QTSession.close();
                           //System.exit(-1);
                       }
                        else if (videoMediaHandler != null) {
                          //controller = new MovieController (theMovie);
                          if(controller.getControllerInfo() == VR_MOVIE)isVRMedia=true;
                          else isVRMedia=false;
                            //System.out.println ("ControllerInfo =" + controller.getControllerInfo());
                            isAudioMedia=false;
                            isTextMedia=false;
                        }
                          contentPane = (JPanel)getContentPane();
                          contentPane.setBorder(lightGrayBorder);
                          canvasPanel = new JPanel();
                          sliderPanel = new JPanel();
                          FlowLayout canvasLyout = new FlowLayout(FlowLayout.CENTER);
                          canvasPanel.setLayout(canvasLyout);
                        if(!isAudioMedia && !isVRMedia && !isTextMedia){
                          mp = new MoviePlayer(m);
                          qtcj = QTFactory.makeQTJComponent(mp);
                          jc = qtcj.asJComponent();
                          canvasPanel.add("Center", jc);
                        }
                        controlButton();
                        manipSlider = new JSlider();
                        manipSlider.addChangeListener(this);
                        manipSlider.addMouseMotionListener(new MouseMotionListener(){
                          public void mouseMoved(MouseEvent e){}
                          public void mouseDragged(MouseEvent e){
                            //startButton.setText("||");
                            startButton.setIcon(createIcon("player_a_02"));
                          }
                        });
                        manipSlider.addMouseListener(new MouseListener(){
                                 public void mousePressed(MouseEvent e) {
                                   JSlider slider = (JSlider)e.getSource();
                                   manipSlider=slider;
                                     try {
                                       clickValue = e.getX()*theMovie.getDuration()/slider.getWidth();
                                       manipSlider.setValue(clickValue);
                                     }
                                     catch (Exception ex) {

                                     }
                                   //}
                                 }
                                 public void mouseReleased(MouseEvent e) {
                                   try {
                                     if(!startStop){
                                       theMovie.stop();
                                       startStop = true;
                                     }
                                     //startButton.setText(">");
                                     startButton.setIcon(createIcon("player_a_01"));
                                  } catch (Exception qte) {
                                       qte.printStackTrace();
                                   }
                                 }
                                 public void mouseClicked(MouseEvent e){}
                                 public void mouseEntered(MouseEvent e) {}
                                 public void mouseExited(MouseEvent e) {}
                        });
                        JSlider slider = createSlider(manipSlider, 0, theMovie.getDuration(), clickValue, 0, 0, true, false, sliderWidth, sliderHeight);
                        slider.setBorder(lightGrayBorder);
                        timeLabel.setBorder(lightGrayBorder);
                        meterPanel = new JPanel();
                        BorderLayout meterLyout = new BorderLayout();
                        meterPanel.setLayout(meterLyout);
                        //FlowLayout flowLayout = new FlowLayout(FlowLayout.LEFT);
                        //sliderPanel.setLayout(flowLayout);
                        //sliderPanel.setBorder(lightGrayBorder);
                        //sliderPanel.add(timeLabel);
                        //sliderPanel.add(slider);
                        meterMinSize = new Dimension(
                           (int)slider.getPreferredSize().getWidth()/4-5,
                               (int)slider.getPreferredSize().getHeight());
                        meterPanel.setMinimumSize(meterMinSize);
                        //sliderPanel.add(meterPanel);
                        GridBagLayout gridBagLayout = new GridBagLayout();
                        sliderPanel.setLayout(gridBagLayout);
                        sliderPanel.add(timeLabel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                                ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 0, 5, 0), 0, 0));
                        sliderPanel.add(slider, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
                                ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 0, 5, 0), 0, 0));
                        sliderPanel.add(meterPanel, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
                                ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 0, 5, 0), 0, 0));
                        if(isVRMedia){
                          sliderPanel.setVisible(false);
                          buttons.setVisible(false);
                          qtc = QTFactory.makeQTComponent(controller);
                          c = qtc.asComponent();
                          canvasPanel.add("Center", c);
                        }
                        else if(isAudioMedia){
                         canvasPanel.setVisible(false);
                         if(f.getName().endsWith(".mid")){
                             meterPanel.setVisible(false);
                         }else{
                             meter = new LevelMeter();
                             meterPanel.add("Center", meter);
                         }
                         meterPanel.setBorder(lightGrayBorder);
                        }
                        BorderLayout contentLayout = new BorderLayout();
                        contentPane.setLayout(contentLayout);
                        contentPane.add (canvasPanel, BorderLayout.NORTH);
                        contentPane.add (sliderPanel, BorderLayout.CENTER);
                        contentPane.add (buttons, BorderLayout.SOUTH);
                        /*GridBagLayout contentLayout = new GridBagLayout();
                        getContentPane().setLayout(contentLayout);
                        getContentPane().add(canvasPanel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                                ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
                        getContentPane().add(sliderPanel, new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0
                                ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
                        getContentPane().add(buttons, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                                ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));*/
                        javax.swing.Timer t = new javax.swing.Timer (1, new ActionListener() {
                                public void actionPerformed (ActionEvent ae) {
                                  try {
                                    manipSlider.setValue(theMovie.getTime());
                                    if(meterPanel.isVisible())
                                    meter.repaint();
                                  }
                                  catch (Exception ex) {

                                  }
                                }
                            });
                        t.start();
                        pack();
                        GUI.center(this);
                        setVisible(true);
                        monitor();
                } catch (Exception e) {
                        QTSession.close();
                        KeyboardFocusManager.getCurrentKeyboardFocusManager().removeKeyEventDispatcher(this);
                        printStackTrace(e);
                }
        }

        private void controlButton() {
            buttons = new JPanel();
            buttons.setBorder(lightGrayBorder);
            FlowLayout buttonsFlowLayout = new FlowLayout(FlowLayout.LEFT, 0, 0);
            buttons.setLayout(buttonsFlowLayout);
            revButton = createButton(revButton, "Revue Button");
            revButton.setIcon(createIcon("player_a_03"));
            revButton.setPressedIcon(createIcon("player_a_03_press"));
            revButton.setRolloverIcon(createIcon("player_a_03_rolover"));
            //setBorderlessButton(revButton);
            //revButton.addMouseListener (this);
            tobeginnButton = createButton(tobeginnButton, "Tobeginn Button");
            tobeginnButton.setIcon(createIcon("player_a_05"));
            tobeginnButton.setPressedIcon(createIcon("player_a_05_press"));
            tobeginnButton.setRolloverIcon(createIcon("player_a_05_rolover"));
            //setBorderlessButton(tobeginnButton);
            //tobeginnButton.addMouseListener (this);
            startButton = createButton(startButton, "Start/Stop Button");
            startButton.setIcon(createIcon("player_a_01"));
            startButton.setRolloverIcon(createIcon("player_a_01_rolover"));
            //setBorderlessButton(startButton);
            //startButton.addMouseListener (this);
            fwdButton = createButton(fwdButton, "Forward Button");
            fwdButton.setIcon(createIcon("player_a_04"));
            fwdButton.setPressedIcon(createIcon("player_a_04_press"));
            fwdButton.setRolloverIcon(createIcon("player_a_04_rolover"));
            //setBorderlessButton(fwdButton);
            //fwdButton.addMouseListener (this);
            toendButton = createButton(toendButton, "Toend Button");
            toendButton.setIcon(createIcon("player_a_06"));
            toendButton.setPressedIcon(createIcon("player_a_06_press"));
            toendButton.setRolloverIcon(createIcon("player_a_06_rolover"));
            //setBorderlessButton(toendButton);
            //revButton.addActionListener (this);
            //toendButton.addMouseListener (this);
            buttons.add (tobeginnButton);
            buttons.add (revButton);
            //buttons.add (stopButton);
            buttons.add (startButton);
            buttons.add (fwdButton);
            buttons.add (toendButton);
        }

        void monitor() throws Exception {
                timeScale = m.getTimeScale();
                double time;
                while (!done) {
                        time = m.getTime()/timeScale;
                        if (time!=previousTime) {
                                IJ.showStatus( getTimeString(time));
                                timeLabel.setText(getTimeString(time));
                                previousTime = time;
                        }
                        IJ.wait(10);
                }
        }

        String getTimeString(double time) throws Exception {
                int minutes = (int)time/60;
                String s1 = minutes + ":";
                if (s1.length()==2)
                        s1 = "0" + s1;
                String s2 = IJ.d2s(time-minutes*60,2);
                if (s2.charAt(1)=='.')
                        s2 = "0" + s2;
                return s1 + s2;
        }

        public void close() {
                done = true;
                QTSession.close();
                setVisible(false);
                dispose();
                WindowManager.removeWindow(this);
                KeyboardFocusManager.getCurrentKeyboardFocusManager().removeKeyEventDispatcher(this);
        }

        void keyPressed (KeyEvent e) {
                //IJ.log("keyPressed: "+e);
                try {
                        //need to pass MovieController.key() an int corresponding to standard Java key code; initialize it here
                        int myInt = 0;
                        switch (e.getKeyCode()) {
                                case KeyEvent.VK_SPACE:
                                        if (m.getRate() != 0)
                                                m.setRate (0);
                                        else
                                                m.setRate (1);
                                        break;
                                case KeyEvent.VK_LEFT:
                                        myInt = KeyEvent.VK_LEFT;
                                        controller.key(myInt,e.getModifiers());
                                        break;
                                case KeyEvent.VK_RIGHT:
                                        myInt = KeyEvent.VK_RIGHT;
                                        controller.key (myInt,e.getModifiers());
                                        break;
                                case KeyEvent.VK_G:
                                        grab();
                                        break;
                                default:
                                        break;
                        }
                } catch (Exception ee) {
                        printStackTrace(ee);
                }
        }

        void grab() {
                Point loc = getLocation();
                Dimension size = getSize();
                try {
                        Robot robot = new Robot();
                        Rectangle r = new Rectangle(loc.x, loc.y+22, size.width, size.height-22-16);
                        Image img = robot.createScreenCapture(r);
                        if (img!=null)
                                new ImagePlus(getTimeString(m.getTime()/timeScale), img).show();
                } catch(Exception e) { }
        }

        void grab2() throws Exception {
                Point loc = getLocation();
                Dimension size = getSize();
                int width = size.width;
                int height = size.height-38;
                QDGraphics gWorld = m.getGWorld();
                int intsPerRow = gWorld.getPixMap().getPixelData().getRowBytes()/4;
                int[] pixelData = new int[intsPerRow*height];
                gWorld.getPixMap().getPixelData().copyToArray(0, pixelData, 0, pixelData.length);
                //IJ.log("Grab: "+gWorld+"   "+gWorld.getPixMap());
                int[] pixels = new int[width*height];
                for (int i=0; i<height; i++)
                        System.arraycopy(pixelData, i*intsPerRow+loc.x, pixels, i*width, width);
                pixelData = pixels;
                ImageProcessor ip= new ColorProcessor(width, height, pixelData);
                new ImagePlus("Frame", ip).show();
        }

        void printStackTrace(Exception e) {
                if (e.toString().indexOf("userCanceledErr")>=0)
                        return;
                CharArrayWriter caw = new CharArrayWriter();
                PrintWriter pw = new PrintWriter(caw);
                e.printStackTrace(pw);
                String s = caw.toString();
                if (IJ.isMacintosh())
                s = Tools.fixNewLines(s);
                new TextWindow("Exception", s, 500, 300);
        }

        public boolean dispatchKeyEvent(KeyEvent e) {
                //IJ.log("dispatchKeyEvent: "+e);
                if (!done && e.getID()==KeyEvent.KEY_PRESSED)
                        keyPressed(e);
                return false;
        }
        /** create and initialize JSlider */
        public JSlider createSlider(JSlider manipSlider, int min, int max, int start, int major, int minor, boolean paintTicks, boolean paintLabels, int width, int height){
           this.manipSlider=manipSlider;
           manipSlider.setMinimum(min);
           manipSlider.setMaximum(max);
           manipSlider.setValue(start);
           manipSlider.setMajorTickSpacing(major);
           manipSlider.setMinorTickSpacing(minor);

           manipSlider.setPaintTicks(paintTicks);
           manipSlider.setPaintLabels(paintLabels);
           manipSlider.setPreferredSize(new Dimension(width, height));
           manipSlider.setMinimumSize(new Dimension(width, height));
           return manipSlider;
            }
            private JButton createButton(JButton action, String tooltip){
                action = new JButton();
                action.setToolTipText(tooltip);
                //action.addActionListener(this);
                action.addMouseListener(this);
                setBorderlessButton(action);
            return action;
            }

            private Icon createIcon(String key){
                Icon icon = null;
                String dir = Prefs.getString("dirPlayer");
                //String dir = "player/";
                String fileName=key+".gif";
                String path = dir+fileName;
                URL url = getClass().getResource(path);
                if(url != null)
                icon = new ImageIcon(url);
            return icon;
            }

             void setBorderlessButton(JButton button){
                  button.setMargin(new Insets(0, 0, 0, 0));
                  button.setBorderPainted(false);
                  button.setContentAreaFilled(false);
                  button.setFocusPainted(false);
              }

        // build current play time
        public void buildCurrentTime() throws Exception{
          int totalSeconds = theMovie.getTime() /
                             theMovie.getTimeScale();
          int seconds = totalSeconds % 60;
          int minutes = totalSeconds / 60;
          int hour = totalSeconds / 3600;
          String secString = (seconds > 9) ?
              Integer.toString (seconds) :
              ("0" + Integer.toString (seconds));
          String minString = (minutes > 9) ?
              Integer.toString (minutes) :
              ("0" + Integer.toString (minutes));
          String hourString = (hour > 9) ?
              Integer.toString (hour) :
              ("0" + Integer.toString (hour));
          timeLabel.setText (hourString + ":" + minString + ":" + secString);
        }

        public void stateChanged(ChangeEvent e){
        JSlider slider = (JSlider)e.getSource();
        try {
          if(startStop){
          theMovie.setTimeValue(slider.getValue());
          }else if(theMovie.getDuration()==slider.getValue()){
            //theMovie.stop();
            startStop=true;
            //startButton.setText(">");
            startButton.setIcon(createIcon("player_a_01"));
            //startButton.setRolloverIcon(createIcon("player_a_01_rolover"));
          }
        }
        catch (Exception ex) {
        }
        }

        public void mousePressed(MouseEvent e) {
            JButton action = (JButton)e.getSource();
            int x = e.getX();
            float rate=0;
            boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
            mouseDownTime = System.currentTimeMillis();
                 if (!doubleClick) {
                     try {
                       if (action == tobeginnButton){
                         theMovie.goToBeginning();
                       }
                         else if (action == revButton){
                           rate=theMovie.getRate();
                           if(rate== 0) rate = -0.5f;
                           theMovie.setRate(rate - 0.5f);
                           //startButton.setText("||");
                           startButton.setIcon(createIcon("player_a_02"));
                        }
                         else if (action == startButton){
                           if(!flipflop){
                             theMovie.start();
                             startStop = false;
                             startButton.setIcon(createIcon("player_a_01_press"));
                             //startButton.setRolloverIcon(createIcon("player_a_01_rolover"));
                            //startButton.setText("||");
                           }else{
                             theMovie.stop();
                             startStop=true;
                             //startButton.setText(">");
                             startButton.setIcon(createIcon("player_a_02_press"));
                             //startButton.setRolloverIcon(createIcon("player_a_02_rolover"));
                          }
                         }
                         else if (action == fwdButton){
                           //rate=theMovie.getRate();
                           //if(rate == 0) rate = 0.5f;
                           //theMovie.setRate(rate + 0.5f);
                           theMovie.start();
                           startStop = false;
                           //startButton.setText("||");
                           startButton.setIcon(createIcon("player_a_02"));
                         }
                         else if (action == toendButton){
                          theMovie.goToEnd();
                         }
                     } catch (QTException qte) {
                         qte.printStackTrace();
                     }

                 }
                 pressed=true;
         }

         public void mouseReleased(MouseEvent e) {
           JButton action = (JButton)e.getSource();
           int x = e.getX();
           float rate=0;
           boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
           mouseDownTime = System.currentTimeMillis();
                if (pressed) {
                    try {
                        if (action == startButton){
                          if(!startStop){
                            flipflop = true;
                            startButton.setIcon(createIcon("player_a_02"));
                            startButton.setRolloverIcon(createIcon("player_a_02_rolover"));
                          }
                          else{ flipflop=false;
                            startButton.setIcon(createIcon("player_a_01"));
                            startButton.setRolloverIcon(createIcon("player_a_01_rolover"));
                          }
                          //action.setText("||");
                        }
                        else if (action == revButton || action == fwdButton){
                          theMovie.stop();
                          startStop=true;
                          //startButton.setText(">");
                          startButton.setIcon(createIcon("player_a_01"));
                        }
                    } catch (QTException qte) {
                        qte.printStackTrace();
                    }

                }
                pressed=false;
         }
         public void mouseExited(MouseEvent e) {}
         public void mouseClicked(MouseEvent e) {}
         public void mouseEntered(MouseEvent e) {}

         /*public void processWindowClosing (WindowEvent e) {
           try {
             QTSession.close();
             //System.exit(0);
           }
           catch (Exception ex) {

           }
         }

         //Overridden so we can exit when window is closed
         protected void processWindowEvent(WindowEvent e) {
           super.processWindowEvent(e);
           if (e.getID() == WindowEvent.WINDOW_CLOSING) {
             processWindowClosing(e);
           }
         }*/

         class LevelMeter extends Canvas {
           //class LevelMeter extends JComponent {
             public Dimension getPreferredSize() { return meterMinSize; }
             public Dimension getMinimumSize() { return meterMinSize; }
             public LevelMeter() throws QTException {
               System.out.println("meterMinSize="+ meterMinSize);
                 MediaEQSpectrumBands bands =
                     new MediaEQSpectrumBands (EQ_LEVELS.length);
                 for (int i=0; i<EQ_LEVELS.length; i++) {
                     bands.setFrequency (i, EQ_LEVELS[i]);
                     audioMediaHandler.setSoundEqualizerBands (bands);
                     audioMediaHandler.setSoundLevelMeteringEnabled (true);
                 }
             }
             public void paintComponent (Graphics g) {
                  //super.paintComponent(g);
                  //paint(g);
             }

             public void paint (Graphics g) {
                 int gHeight = this.getHeight();
                 int gWidth = this.getWidth();
                 //LevelMeter.this.setBackground(Color.blue.brighter().brighter());
                 //LevelMeter.this.setBackground(new Color(144,152,248));
                 //LevelMeter.this.setBackground(new Color(224,224,248));

                 // draw baseline
                 g.drawLine (0, gHeight, gWidth, gHeight);
                 try {
                     if (audioMediaHandler != null) {
                         int[] levels =
                             audioMediaHandler.getSoundEqualizerBandLevels(EQ_LEVELS.length);
                         int maxHeight = gHeight - 1;
                         int barWidth = gWidth / levels.length;

                         // boolean foundDud = false;
                         int segInterval = gHeight / 8;
                         // calculate height of each set of boxes,
                         // proportional to level
                         for (int i=0; i<levels.length; i++) {
                             float levPct = ((float)levels[i]) / 255.0f;
                             // math is a little weird here; y axis has 0 at top,
                             // but we have 0 at bottom of this graph
                             //System.out.println ("levels.length=" + levPct+", "+maxHeight);
                             int barHeight = (int) (levPct * maxHeight);
                             // draw the bar as set of 0-20 rectangles
                             int barCount = 0;
                             for (int j=maxHeight;
                                  j > (maxHeight - barHeight);
                                  j-=segInterval) {
                                 switch (barCount) {
                                 case 20:
                                 case 19:
                                 case 18:
                                     g.setColor (Color.red);
                                     break;
                                 case 17:
                                 case 16:
                                 case 15:
                                     g.setColor (Color.yellow);
                                     break;
                                 default:
                                   g.setColor (Color.black);
                                   //g.setColor (new Color(255, 255, 204));
                                 }
                                 g.fillRect (i * barWidth,
                                             j - segInterval,
                                             barWidth - 1,
                                             segInterval - 1);//System.out.println (" j - segInterval=" +  (j - segInterval));
                                 barCount++;
                             }
                         }
                     }
                 } catch (QTException qte) {
                     qte.printStackTrace();
                 }

             }

    }
}






